package com.hzya.frame.plugin.dgx.oa.service;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.IBaseService;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;

public interface ISalesOrderService extends IBaseService<SalesOrderEntity,String> {

    /**
     *
     * @content 查询OA销售订单数据推送到U9C
     * @Param
     * @Return
     * @Author hecan
     * @Date 2024-09-06 14:29
     * **/
    Object querySalesOrderToU9C(JSONObject json);
    
    /**
     * 
     * @content 将OA中已审核得销售订单推送U9C
     * @Param 
     * @Return 
     * @Author hecan 
     * @Date 2024-09-06 16:59
     * **/
    Object querySalesOrderToU9CByAudit(JSONObject json);

    /**
     *
     * @content 获取数据源以及头部参数
     * @Param
     * @Return
     * @Author hecan
     * @Date 2024-09-06 17:56
     * **/
    SysExtensionApiEntity getHeadsParasm(SysExtensionApiEntity sysExtensionApiEntity);

    /**
     *
     * @content 更新推送状态
     * @Param
     * @Return
     * @Author hecan
     * @Date 2024-09-18 16:57
     * **/
    Integer updateSalesOrderStatus(JSONObject json);
}
