package com.hzya.frame.plugin.dgx.oa.service.impl;


import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.IPaymentOrderDao;
import com.hzya.frame.plugin.dgx.oa.dao.ISalesOrderDao;
import com.hzya.frame.plugin.dgx.oa.entity.PaymentOrderEntity;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.CfsLogEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.IPaymentOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.web.entity.BaseResult;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service(value = "PaymentOrderServiceImpl")
public class PaymentOrderServiceImpl extends BaseService implements IPaymentOrderService {

    @Autowired
    private CfsLogServiceImpl cfsLogService;

    private IPaymentOrderDao paymentOrderDao;

    @Autowired
    public void setPaymentOrderDao(IPaymentOrderDao dao) {
        this.paymentOrderDao = dao;
        this.dao=dao;
    }

    private  static String URLTEST="http://122.224.56.190:8082";
    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    //将付款单推送U9C
    @Override
    public Object queryPaymentOrderToU9C(JSONObject json) {
        /*JSONObject jsonObject = json.getJSONObject("jsonStr");
        if(!checkStr(jsonObject.getString("formApp"))){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        JSONObject businessDataStr = jsonObject.getJSONObject("businessDataStr");
        if(null!=businessDataStr){
            JSONObject formmainData = businessDataStr.getJSONObject("formmain_0673");//主表
            JSONArray forsonData = businessDataStr.getJSONArray("formson_0674");//明细表
            JSONObject jsonMain=new JSONObject();
            jsonMain.put("SrcBillOrgCode",formmainData.getString(""));//来源组织
            jsonMain.put("BizOrgCode",formmainData.getString(""));//业务组织
            jsonMain.put("DocumentTypeCode","APP001");//单据类型
            jsonMain.put("PayObjType",formmainData.getString("field0027"));//付款对象
            jsonMain.put("SuppCode",formmainData.getString("field0030"));//供应商
            jsonMain.put("SuppName",formmainData.getString("field0030"));//供应商名称
            jsonMain.put("SuppSiteCode",formmainData.getString("field0019"));//供应商位置
            jsonMain.put("SuppSiteName",formmainData.getString("field0019"));//供应商位置名称
            jsonMain.put("CustCode",formmainData.getString(""));//客户
            jsonMain.put("CustName",formmainData.getString(""));//客户名称
            jsonMain.put("CustSiteCode",formmainData.getString(""));//客户位置
            jsonMain.put("CustSiteName",formmainData.getString(""));//客户位置名称
            jsonMain.put("PayDate",formmainData.getString("field0025"));//付款日期
            jsonMain.put("PCCode","C001");//币种
            jsonMain.put("Note",formmainData.getString(""));//备注
            if(CollectionUtils.isNotEmpty(forsonData)){
                JSONArray jsonArray=new JSONArray();
                for (Object forsonDatum : forsonData) {
                    JSONObject jsonPayBillLines = JSON.parseObject(JSON.toJSONString(forsonDatum));
                    JSONObject jsonDetails=new JSONObject();
                    jsonDetails.put("LineNum",jsonPayBillLines.getString("field0001"));//行号
                    jsonDetails.put("SettlementMethodCode",jsonPayBillLines.getString("field0002"));//结算方式
                    jsonDetails.put("NoteNo",jsonPayBillLines.getString("field0003"));//票据号
                    jsonDetails.put("PayBkAccCode",jsonPayBillLines.getString("field0007"));//付款银行账号
                    jsonDetails.put("PayBACCode",jsonPayBillLines.getString("field0008"));//账户币种
                    JSONObject jsonDesc=new JSONObject();
                    jsonDesc.put("PrivateDescSeg2",jsonPayBillLines.getString(""));//睿本云订单号
                    jsonDetails.put("DescFlexField",jsonDesc);

                    JSONArray jsonPayBillUseLines = jsonPayBillLines.getJSONArray("");//某一个属性是用来获取PayBillUseLines得
                    if (CollectionUtils.isNotEmpty(jsonPayBillUseLines)) {
                        JSONArray jsonArrayUseLine=new JSONArray();
                        for (Object jsonPayBillUseLine : jsonPayBillUseLines) {
                            JSONObject PayBillUseLine = JSON.parseObject(JSON.toJSONString(jsonPayBillUseLine));
                            JSONObject jsonPayBillUse=new JSONObject();
                            jsonPayBillUse.put("LineNum",PayBillUseLine.getString(""));//行号
                            jsonPayBillUse.put("BizOrgCode",PayBillUseLine.getString(""));//业务组织
                            jsonPayBillUse.put("Money",PayBillUseLine.getString(""));//金额
                            jsonPayBillUse.put("SettlementFee",PayBillUseLine.getString(""));//手续费
                            jsonPayBillUse.put("PayProperty","0");//用途
                            jsonArrayUseLine.add(jsonPayBillUse);
                            jsonDetails.put("PayBillUseLines",jsonArrayUseLine);
                        }
                    }
                    jsonArray.add(jsonDetails);
                    jsonMain.put("PayBillLines",jsonArray);
                }
            }
            String parasm = jsonMain.toJSONString();
            logger.info("====OA付款单传递德广信U9C得请求参数为:{}======",parasm);
            //此处调用中台上得api接口，转发到付款单保存
        }*/

        JSONObject jsonObject = json.getJSONObject("jsonStr");
        logger.info("====付款单得formApp为:{}=====",jsonObject.getString("formApp"));
        //付款单得formAppid
        if(!checkStr(jsonObject.getString("formApp")) && jsonObject.getString("formApp").equals("")){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        PaymentOrderEntity paymentOrderEntity = jsonObject.toJavaObject(PaymentOrderEntity.class);
        if(null == paymentOrderEntity){
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        try {
            String token = acquireTokenService.getToken();
            logger.info("获取得德广信U9Ctoken为：{}",token);
            if(StrUtil.isNotEmpty(token)){
                String params = JSONObject.toJSONString(paymentOrderEntity);
                //调用U9C付款单新增接口
                logger.info("====OA付款单传递德广信U9C得请求参数为:{}======",params);
                String body = HttpRequest.post(URLTEST + "/U9C/webapi/PayBill/Create").header("toke", token).header("content-type", "application/json").body(params).execute().body();
                logger.info("====OA付款单传递德广信U9C得返回参数为:{}======",body);
                JSONObject jsonBody = JSONObject.parseObject(body);
                JSONArray jsonArray = jsonBody.getJSONArray("Data");
                JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArray.get(0)));
                String mCode = jsonData.getString("");
                logger.info("=====德广信U9C付款单新增返回得付款订单号为:{}===",mCode);
                paymentOrderEntity.setDocNo(mCode);
                paymentOrderDao.updatePaymentOrderDocNo(paymentOrderEntity);
                OAWorkflowEventDataEntity oaWorkflowEventDataEntity=new OAWorkflowEventDataEntity();
                oaWorkflowEventDataEntity.setId(jsonObject.getString("id"));
                oaWorkflowEventDataEntity.setFormApp(jsonObject.getString("formApp"));
                oaWorkflowEventDataEntity.setBusinessDataStr(paymentOrderEntity.getDocNo());
                cfsLogService.importCfsLog(new CfsLogEntity("销售订单","formmain_0666",oaWorkflowEventDataEntity,body));
            }
        }catch (Exception e){
            logger.info("========OA付款单推送U9C失败:{}=========",e.getMessage());
        }

        return null;
    }

    @Override
    public Integer updatePaymentOrderStatus(JSONObject json) {
        return null;
    }
}
