package com.hzya.frame.plugin.dgx.oa.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.dgx.oa.dao.ISalesOrderDao;
import com.hzya.frame.plugin.dgx.oa.entity.SalesOrderEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.CfsLogEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.plugin.dgx.oa.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.plugin.dgx.oa.service.ISalesOrderService;
import com.hzya.frame.plugin.dgx.u9c.service.impl.AcquireTokenServiceImpl;
import com.hzya.frame.sysnew.application.database.dao.ISysApplicationDatabaseDao;
import com.hzya.frame.sysnew.application.database.entity.SysApplicationDatabaseEntity;
import com.hzya.frame.sysnew.application.entity.SysApplicationEntity;
import com.hzya.frame.sysnew.application.entity.SysExtensionApiEntity;
import com.hzya.frame.web.entity.BaseResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service(value = "SalesOrderServiceImpl")
public class SalesOrderServiceImpl extends BaseService<SalesOrderEntity,String> implements ISalesOrderService {

    private ISalesOrderDao salesOrderDao;

    @Autowired
    public void setSalesOrderDao(ISalesOrderDao dao) {
        this.salesOrderDao = dao;
        this.dao=dao;
    }


    private  static String URLTEST="http://122.224.56.190:8082";

    @Autowired
    private ISysApplicationDatabaseDao sysApplicationDatabaseDao;

    @Autowired
    private AcquireTokenServiceImpl acquireTokenService;

    @Autowired
    private CfsLogServiceImpl cfsLogService;

    //查询OA销售订单传递U9C
    @Override
    public Object querySalesOrderToU9C(JSONObject json) {
       /* JSONObject jsonObject = json.getJSONObject("jsonStr");
        if(!checkStr(jsonObject.getString("formApp"))){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        try {
            JSONObject businessDataStr = jsonObject.getJSONObject("businessDataStr");
            if(null !=businessDataStr){
                JSONObject formmainData = businessDataStr.getJSONObject("formmain_0666");//主表
                JSONArray forsonData = businessDataStr.getJSONArray("formson_0667");//明细表
                JSONObject jsonMain=new JSONObject();
                jsonMain.put("OrgCode",formmainData.getString(""));//组织
                jsonMain.put("DocumentType","S01");//单据类型
                jsonMain.put("DocNo",formmainData.getString("field0005"));//单号
                jsonMain.put("OrderBy",formmainData.getString("field0009"));//客户
                jsonMain.put("BusinessDate",formmainData.getString("field0017"));//日期
                jsonMain.put("SaleDepartment",formmainData.getString("field0010"));//部门
                jsonMain.put("Seller",formmainData.getString("field0006"));//业务员
                jsonMain.put("IsPriceIncludeTax",true);//价格是否含税
                jsonMain.put("Memo",formmainData.getString("field0020"));//备注
                if(CollectionUtils.isNotEmpty(forsonData)){
                    JSONArray jsonArray=new JSONArray();
                    for (Object forsonDatum : forsonData) {
                        JSONObject jsonSOLineDTOList = JSON.parseObject(JSON.toJSONString(forsonDatum));
                        JSONObject jsonDetails=new JSONObject();
                        jsonDetails.put("ShipTogetherFlag","-1");//成套发货标志
                        jsonDetails.put("TradePath",jsonSOLineDTOList.getString(""));//贸易路径
                        jsonDetails.put("DocLineNo",jsonSOLineDTOList.getString("field0021"));//行号
                        jsonDetails.put("ItemCode",jsonSOLineDTOList.getString("field0028"));//料号
                        jsonDetails.put("OrderByQtyTU",jsonSOLineDTOList.getString("field0031"));//数量
                        jsonDetails.put("OrderByQtyPU",jsonSOLineDTOList.getString(""));//计价数量
                        jsonDetails.put("FinallyPriceTC",jsonSOLineDTOList.getString("field0036"));//最终价
                        jsonDetails.put("NetMoneyTC",jsonSOLineDTOList.getString("field0039"));//未税价格
                        jsonDetails.put("TaxMoneyTC",jsonSOLineDTOList.getString("field0040"));//税额
                        jsonDetails.put("DiscountTC",jsonSOLineDTOList.getString("field0037"));//折扣率
                        jsonDetails.put("TotalMoneyTC",jsonSOLineDTOList.getString("field0038"));//价税合计
                        jsonDetails.put("PriceSource",jsonSOLineDTOList.getString(""));//价格来源
                        jsonDetails.put("TaxSchedule","YZ08");//税组合
                        jsonDetails.put("Memo",jsonSOLineDTOList.getString("field0042"));//备注
                        jsonDetails.put("FreeType",jsonSOLineDTOList.getString("field0034"));//免费品类型
                        JSONObject jsonDesc=new JSONObject();
                        jsonDesc.put("PrivateDescSeg2",jsonSOLineDTOList.getString(""));//睿本云订单号
                        jsonDetails.put("DescFlexField",jsonDesc);

                        JSONArray jsonSOShiplineDTOList = jsonSOLineDTOList.getJSONArray("");//某一个属性是用来获取SOShiplineDTOList得
                        if(CollectionUtils.isNotEmpty(jsonSOShiplineDTOList)){
                            JSONArray jsonArrayLineDTO=new JSONArray();
                            for (Object o : jsonSOShiplineDTOList) {
                                JSONObject jsonSOShiplineDTOListObject = JSON.parseObject(JSON.toJSONString(o));
                                JSONObject jsonObjectShiplineDTO=new JSONObject();
                                jsonObjectShiplineDTO.put("ItemCode",jsonSOLineDTOList.getString("field0028"));//料号
                                jsonObjectShiplineDTO.put("SupplySource",jsonSOShiplineDTOListObject.getString(""));//供应来源
                                jsonObjectShiplineDTO.put("DemandTransformType",jsonSOShiplineDTOListObject.getString(""));//供应类型
                                jsonObjectShiplineDTO.put("ShiperOrg",jsonSOShiplineDTOListObject.getString(""));//货主组织
                                jsonObjectShiplineDTO.put("SupplyOrg",jsonSOShiplineDTOListObject.getString(""));//供应组织
                                jsonObjectShiplineDTO.put("RequireDate",jsonSOShiplineDTOListObject.getString(""));//交期
                                jsonArrayLineDTO.add(jsonObjectShiplineDTO);
                                jsonDetails.put("SOShiplineDTOList",jsonArrayLineDTO);
                            }
                        }

                        jsonArray.add(jsonDetails);
                        jsonMain.put("SOLineDTOList",jsonArray);
                    }
                }
                String parasm = jsonMain.toJSONString();
                logger.info("====OA销售订单传递德广信U9C得请求参数为:{}======",parasm);
                //此处调用中台上得api接口，转发到销售订单保存
            }
        }catch (Exception e){
            logger.info("========OA销售订单推送U9C失败:{}=========",e.getMessage());
        }
        return null;*/

        JSONObject jsonObject = json.getJSONObject("jsonStr");
        logger.info("====销售订单得formApp为:{}=====",jsonObject.getString("formApp"));
        //销售订单得formAppid
        if(!checkStr(jsonObject.getString("formApp")) && jsonObject.getString("formApp").equals("")){
            return BaseResult.getFailureMessageEntity("formApp不能为空");
        }
        SalesOrderEntity salesOrderEntity = jsonObject.toJavaObject(SalesOrderEntity.class);
        if(null == salesOrderEntity){
            return BaseResult.getFailureMessageEntity("参数不允许为空");
        }
        try {
            String token = acquireTokenService.getToken();
            logger.info("获取得德广信U9Ctoken为：{}",token);
            if(StrUtil.isNotEmpty(token)){
                String params = JSONObject.toJSONString(salesOrderEntity);
                //调用U9C销售订单新增接口
                logger.info("====OA销售订单传递德广信U9C得请求参数为:{}======",params);
                String body = HttpRequest.post(URLTEST + "/U9C/webapi/SO/Create").header("toke", token).header("content-type", "application/json").body(params).execute().body();
                logger.info("====OA销售订单传递德广信U9C得返回参数为:{}======",body);
                JSONObject jsonBody = JSONObject.parseObject(body);
                JSONArray jsonArray = jsonBody.getJSONArray("Data");
                JSONObject jsonData = JSON.parseObject(JSON.toJSONString(jsonArray.get(0)));
                String mCode = jsonData.getString("m_code");
                logger.info("=====德广信U9C销售订单新增返回得销售订单号为:{}===",mCode);
                salesOrderEntity.setDocNo(mCode);
                salesOrderDao.updateSalesOrderDocNo(salesOrderEntity);
                OAWorkflowEventDataEntity oaWorkflowEventDataEntity=new OAWorkflowEventDataEntity();
                oaWorkflowEventDataEntity.setId(jsonObject.getString("id"));
                oaWorkflowEventDataEntity.setFormApp(jsonObject.getString("formApp"));
                oaWorkflowEventDataEntity.setBusinessDataStr(salesOrderEntity.getDocNo());
                cfsLogService.importCfsLog(new CfsLogEntity("销售订单","formmain_0666",oaWorkflowEventDataEntity,body));
            }
        }catch (Exception e){
            logger.info("========OA销售订单推送U9C失败:{}=========",e.getMessage());
        }

        return null;
    }

    //将已审核得销售订单传递U9C
    @Override
    public Object querySalesOrderToU9CByAudit(JSONObject json) {
        return null;
    }

    @Override
    public SysExtensionApiEntity getHeadsParasm(SysExtensionApiEntity sysExtensionApiEntity) {
        try {
            Map<String, String> headers = sysExtensionApiEntity.getHeaders();
            String formmainTableName = headers.get("formmainTableName");
            String forsonTableName = headers.get("forsonTableName");
            SysApplicationEntity applicationEntity = sysExtensionApiEntity.getReceiveApp();
            SysApplicationDatabaseEntity sysApplicationDatabaseEntity = new SysApplicationDatabaseEntity();
            sysApplicationDatabaseEntity.setSts("Y");
            sysApplicationDatabaseEntity.setAppId(applicationEntity.getId());
            sysApplicationDatabaseEntity.setDataSourceCode("master");
            List<SysApplicationDatabaseEntity> sysDataSourceEntities = sysApplicationDatabaseDao.queryDSBase(sysApplicationDatabaseEntity);
            if (sysDataSourceEntities != null && sysDataSourceEntities.size() > 0) {
                String parm = sysExtensionApiEntity.getBodys();
                JSONObject jsonObject = JSONObject.parseObject(parm);
                jsonObject.put("dataSourceCode", sysDataSourceEntities.get(0).getSourceCode());
                jsonObject.put("formmainTableName",formmainTableName);
                jsonObject.put("forsonTableName",forsonTableName);
                sysExtensionApiEntity.setBodys(jsonObject.toJSONString());
            }

        }catch (Exception e){
            logger.info("====OA销售订单获取头部参数错误:{}======",e.getMessage());
        }
        return null;
    }

    //更新推送状态
    @Override
    public Integer updateSalesOrderStatus(JSONObject json) {
        return null;
    }
}
